image: mcr.microsoft.com/dotnet/sdk:7.0

stages:
  - build
  - sonarqube

build:
  stage: build
  before_script:
    - dotnet restore
  script:
    - dotnet build

sonarqube:
  stage: sonarqube
  image: mcr.microsoft.com/dotnet/sdk:7.0
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script: 
      - "apt-get update"
      - "apt-get install --yes openjdk-11-jre"
      - "dotnet tool install --global dotnet-sonarscanner"
      - "export PATH=\"$PATH:$HOME/.dotnet/tools\""
      - "dotnet sonarscanner begin /k:\"c3a63b26-1115-11ee-be56-0242ac120002\" /d:sonar.login=\"$SONAR_TOKEN\" /d:\"sonar.host.url=$SONAR_HOST_URL\" /d:sonar.qualitygate.wait=true "
      - "dotnet build"
      - "dotnet sonarscanner end /d:sonar.login=\"$SONAR_TOKEN\""
  allow_failure: false
  only:
    - main # or the name of your main branchset ftp:passive-mode true; set ftp:prefer-epsv false; mirror -R /builds/world-conquer-online/canyon/canyon.gm.panel/Bin/Release/net7.0/publish /" -u $FTP_USERNAME,$FTP_PASSWORD $FTP_HOSTNAME